import { App } from 'vue';
import * as Three from 'three';
import ModelObj from './model-obj.vue';
import ModelFbx from './model-fbx.vue';
import ModelThree from './model-three.vue';
import ModelStl from './model-stl.vue';
import ModelPly from './model-ply.vue';
import ModelCollada from './model-collada.vue';
import ModelGltf from './model-gltf.vue';
export { Three };
declare const ModelJson: import("vue").DefineComponent<{}, {}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").DefineComponent<any, {}, {
    loader: Three.ObjectLoader;
}, {}, {}, import("vue").DefineComponent<{
    src: {
        type: StringConstructor;
    };
    width: {
        type: NumberConstructor;
    };
    height: {
        type: NumberConstructor;
    };
    position: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    rotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    scale: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    lights: {
        type: import("vue").PropType<{
            [key: string]: any;
            type: string;
        }[]>;
        default: () => never[];
    };
    cameraPosition: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraRotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraUp: {
        type: ObjectConstructor;
    };
    cameraLookAt: {
        type: ObjectConstructor;
    };
    backgroundColor: {
        default: number;
    };
    backgroundAlpha: {
        type: NumberConstructor;
        default: number;
    };
    controlsOptions: {
        type: ObjectConstructor;
    };
    crossOrigin: {
        type: StringConstructor;
        default: string;
    };
    requestHeader: {
        type: ObjectConstructor;
        default: () => void;
    };
    outputEncoding: {
        type: NumberConstructor;
        default: Three.TextureEncoding;
    };
    glOptions: {
        type: ObjectConstructor;
    };
}, unknown, {
    object: Three.Object3D<Three.Event> | null;
    raycaster: Three.Raycaster;
    mouse: Three.Vector2;
    camera: Three.PerspectiveCamera;
    scene: Three.Scene;
    wrapper: Three.Object3D<Three.Event>;
    renderer: Three.WebGLRenderer | null;
    controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
    allLights: Three.Light[];
    clock: DateConstructor | Performance;
    reqId: number | null;
    loader: Three.Loader;
} & {
    size: {
        width: number | undefined;
        height: number | undefined;
    };
    progress: {
        startedAt?: number | undefined;
        endedAt?: number | undefined;
        isComplete: boolean;
        lengthComputable: boolean;
        loaded: number;
        total: number;
    };
}, {
    loadProgressPercentage(): number;
}, {
    onResize(): void;
    onMouseDown(event: MouseEvent): void;
    onMouseMove(event: MouseEvent): void;
    onMouseUp(event: MouseEvent): void;
    onClick(event: MouseEvent): void;
    onDblclick(event: MouseEvent): void;
    pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
    update(): void;
    updateModel(): void;
    updateRenderer(): void;
    updateCamera(): void;
    updateLights(): void;
    updateControls(): void;
    reportProgress(type: "start" | "end" | "progress", data?: {
        lengthComputable: boolean;
        loaded: number;
        total: number;
    } | undefined): void;
    load(): void;
    process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
    getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
    addObject(object: Three.Object3D<Three.Event>): void;
    animate(): void;
    render(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    src: {
        type: StringConstructor;
    };
    width: {
        type: NumberConstructor;
    };
    height: {
        type: NumberConstructor;
    };
    position: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    rotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    scale: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    lights: {
        type: import("vue").PropType<{
            [key: string]: any;
            type: string;
        }[]>;
        default: () => never[];
    };
    cameraPosition: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraRotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraUp: {
        type: ObjectConstructor;
    };
    cameraLookAt: {
        type: ObjectConstructor;
    };
    backgroundColor: {
        default: number;
    };
    backgroundAlpha: {
        type: NumberConstructor;
        default: number;
    };
    controlsOptions: {
        type: ObjectConstructor;
    };
    crossOrigin: {
        type: StringConstructor;
        default: string;
    };
    requestHeader: {
        type: ObjectConstructor;
        default: () => void;
    };
    outputEncoding: {
        type: NumberConstructor;
        default: Three.TextureEncoding;
    };
    glOptions: {
        type: ObjectConstructor;
    };
}>>, {
    position: Record<string, any>;
    rotation: Record<string, any>;
    scale: Record<string, any>;
    lights: {
        [key: string]: any;
        type: string;
    }[];
    backgroundAlpha: number;
    backgroundColor: number;
    cameraPosition: Record<string, any>;
    cameraRotation: Record<string, any>;
    crossOrigin: string;
    requestHeader: Record<string, any>;
    outputEncoding: number;
}>, import("vue").ComponentOptionsMixin, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<any>, {} | {
    [x: string]: any;
}>, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>;
declare const ModelDae: import("vue").DefineComponent<{}, {}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").DefineComponent<{
    lights: {
        type: ArrayConstructor;
        default: () => ({
            type: string;
            position: {
                x: number;
                y: number;
                z: number;
            };
            skyColor: number;
            groundColor: number;
            intensity: number;
            color?: undefined;
        } | {
            type: string;
            position: {
                x: number;
                y: number;
                z: number;
            };
            color: number;
            intensity: number;
            skyColor?: undefined;
            groundColor?: undefined;
        })[];
    };
    smoothing: {
        type: BooleanConstructor;
        default: boolean;
    };
}, unknown, {
    loader: import("three/examples/jsm/loaders/ColladaLoader").ColladaLoader;
}, {}, {
    getObject(collada: any): any;
}, import("vue").DefineComponent<{
    src: {
        type: StringConstructor;
    };
    width: {
        type: NumberConstructor;
    };
    height: {
        type: NumberConstructor;
    };
    position: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    rotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    scale: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    lights: {
        type: import("vue").PropType<{
            [key: string]: any;
            type: string;
        }[]>;
        default: () => never[];
    };
    cameraPosition: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraRotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraUp: {
        type: ObjectConstructor;
    };
    cameraLookAt: {
        type: ObjectConstructor;
    };
    backgroundColor: {
        default: number;
    };
    backgroundAlpha: {
        type: NumberConstructor;
        default: number;
    };
    controlsOptions: {
        type: ObjectConstructor;
    };
    crossOrigin: {
        type: StringConstructor;
        default: string;
    };
    requestHeader: {
        type: ObjectConstructor;
        default: () => void;
    };
    outputEncoding: {
        type: NumberConstructor;
        default: Three.TextureEncoding;
    };
    glOptions: {
        type: ObjectConstructor;
    };
}, unknown, {
    object: Three.Object3D<Three.Event> | null;
    raycaster: Three.Raycaster;
    mouse: Three.Vector2;
    camera: Three.PerspectiveCamera;
    scene: Three.Scene;
    wrapper: Three.Object3D<Three.Event>;
    renderer: Three.WebGLRenderer | null;
    controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
    allLights: Three.Light[];
    clock: DateConstructor | Performance;
    reqId: number | null;
    loader: Three.Loader;
} & {
    size: {
        width: number | undefined;
        height: number | undefined;
    };
    progress: {
        startedAt?: number | undefined;
        endedAt?: number | undefined;
        isComplete: boolean;
        lengthComputable: boolean;
        loaded: number;
        total: number;
    };
}, {
    loadProgressPercentage(): number;
}, {
    onResize(): void;
    onMouseDown(event: MouseEvent): void;
    onMouseMove(event: MouseEvent): void;
    onMouseUp(event: MouseEvent): void;
    onClick(event: MouseEvent): void;
    onDblclick(event: MouseEvent): void;
    pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
    update(): void;
    updateModel(): void;
    updateRenderer(): void;
    updateCamera(): void;
    updateLights(): void;
    updateControls(): void;
    reportProgress(type: "start" | "end" | "progress", data?: {
        lengthComputable: boolean;
        loaded: number;
        total: number;
    } | undefined): void;
    load(): void;
    process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
    getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
    addObject(object: Three.Object3D<Three.Event>): void;
    animate(): void;
    render(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    src: {
        type: StringConstructor;
    };
    width: {
        type: NumberConstructor;
    };
    height: {
        type: NumberConstructor;
    };
    position: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    rotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    scale: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    lights: {
        type: import("vue").PropType<{
            [key: string]: any;
            type: string;
        }[]>;
        default: () => never[];
    };
    cameraPosition: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraRotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraUp: {
        type: ObjectConstructor;
    };
    cameraLookAt: {
        type: ObjectConstructor;
    };
    backgroundColor: {
        default: number;
    };
    backgroundAlpha: {
        type: NumberConstructor;
        default: number;
    };
    controlsOptions: {
        type: ObjectConstructor;
    };
    crossOrigin: {
        type: StringConstructor;
        default: string;
    };
    requestHeader: {
        type: ObjectConstructor;
        default: () => void;
    };
    outputEncoding: {
        type: NumberConstructor;
        default: Three.TextureEncoding;
    };
    glOptions: {
        type: ObjectConstructor;
    };
}>>, {
    position: Record<string, any>;
    rotation: Record<string, any>;
    scale: Record<string, any>;
    lights: {
        [key: string]: any;
        type: string;
    }[];
    backgroundAlpha: number;
    backgroundColor: number;
    cameraPosition: Record<string, any>;
    cameraRotation: Record<string, any>;
    crossOrigin: string;
    requestHeader: Record<string, any>;
    outputEncoding: number;
}>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    lights: {
        type: ArrayConstructor;
        default: () => ({
            type: string;
            position: {
                x: number;
                y: number;
                z: number;
            };
            skyColor: number;
            groundColor: number;
            intensity: number;
            color?: undefined;
        } | {
            type: string;
            position: {
                x: number;
                y: number;
                z: number;
            };
            color: number;
            intensity: number;
            skyColor?: undefined;
            groundColor?: undefined;
        })[];
    };
    smoothing: {
        type: BooleanConstructor;
        default: boolean;
    };
}>>, {
    lights: unknown[];
    smoothing: boolean;
}>, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>;
declare const install: (app: App) => void;
declare const _default: {
    install: (app: App<any>) => void;
    ModelObj: import("vue").DefineComponent<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
        smoothing: {
            type: BooleanConstructor;
            default: boolean;
        };
        mtlPath: {
            type: StringConstructor;
        };
        mtl: {
            type: StringConstructor;
        };
    }, unknown, {
        loader: import("three/examples/jsm/loaders/OBJLoader").OBJLoader;
        mtlLoader: import("three/examples/jsm/loaders/MTLLoader").MTLLoader;
    }, {}, {
        process(object: Three.Object3D<Three.Event>): void;
        load(this: any): void;
    }, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
        smoothing: {
            type: BooleanConstructor;
            default: boolean;
        };
        mtlPath: {
            type: StringConstructor;
        };
        mtl: {
            type: StringConstructor;
        };
    }>>, {
        lights: unknown[];
        smoothing: boolean;
    }>;
    ModelFbx: import("vue").DefineComponent<{
        lights: {
            type: ArrayConstructor;
            default(): ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
    }, unknown, {
        loader: import("three/examples/jsm/loaders/FBXLoader").FBXLoader;
    }, {}, {
        getObject(geometry: any): any;
    }, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        lights: {
            type: ArrayConstructor;
            default(): ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
    }>>, {
        lights: unknown[];
    }>;
    ModelThree: import("vue").DefineComponent<any, {}, {
        loader: Three.ObjectLoader;
    }, {}, {}, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<any>, {} | {
        [x: string]: any;
    }>;
    ModelJson: import("vue").DefineComponent<{}, {}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").DefineComponent<any, {}, {
        loader: Three.ObjectLoader;
    }, {}, {}, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<any>, {} | {
        [x: string]: any;
    }>, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>;
    ModelStl: import("vue").DefineComponent<{
        lights: {
            type: ArrayConstructor;
            default(): ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
    }, unknown, {
        loader: import("three/examples/jsm/loaders/STLLoader").STLLoader;
    }, {}, {
        getObject(geometry: Three.BufferGeometry): Three.Mesh<Three.BufferGeometry, Three.MeshPhongMaterial>;
    }, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        lights: {
            type: ArrayConstructor;
            default(): ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
    }>>, {
        lights: unknown[];
    }>;
    ModelPly: import("vue").DefineComponent<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
    }, unknown, {
        loader: import("three/examples/jsm/loaders/PLYLoader").PLYLoader;
    }, {}, {
        getObject(geometry: Three.BufferGeometry): Three.Mesh<Three.BufferGeometry, Three.MeshStandardMaterial>;
    }, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
    }>>, {
        lights: unknown[];
    }>;
    ModelCollada: import("vue").DefineComponent<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
        smoothing: {
            type: BooleanConstructor;
            default: boolean;
        };
    }, unknown, {
        loader: import("three/examples/jsm/loaders/ColladaLoader").ColladaLoader;
    }, {}, {
        getObject(collada: any): any;
    }, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
        smoothing: {
            type: BooleanConstructor;
            default: boolean;
        };
    }>>, {
        lights: unknown[];
        smoothing: boolean;
    }>;
    ModelDae: import("vue").DefineComponent<{}, {}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").DefineComponent<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
        smoothing: {
            type: BooleanConstructor;
            default: boolean;
        };
    }, unknown, {
        loader: import("three/examples/jsm/loaders/ColladaLoader").ColladaLoader;
    }, {}, {
        getObject(collada: any): any;
    }, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                skyColor: number;
                groundColor: number;
                intensity: number;
                color?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
                skyColor?: undefined;
                groundColor?: undefined;
            })[];
        };
        smoothing: {
            type: BooleanConstructor;
            default: boolean;
        };
    }>>, {
        lights: unknown[];
        smoothing: boolean;
    }>, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>;
    ModelGltf: import("vue").DefineComponent<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                color: number;
                position?: undefined;
                intensity?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
            })[];
        };
        gammaOutput: {
            type: BooleanConstructor;
            default: boolean;
        };
    }, unknown, {
        loader: import("three/examples/jsm/loaders/GLTFLoader").GLTFLoader;
    }, {}, {
        load(): void;
    }, import("vue").DefineComponent<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }, unknown, {
        object: Three.Object3D<Three.Event> | null;
        raycaster: Three.Raycaster;
        mouse: Three.Vector2;
        camera: Three.PerspectiveCamera;
        scene: Three.Scene;
        wrapper: Three.Object3D<Three.Event>;
        renderer: Three.WebGLRenderer | null;
        controls: import("three/examples/jsm/controls/OrbitControls").OrbitControls | null;
        allLights: Three.Light[];
        clock: DateConstructor | Performance;
        reqId: number | null;
        loader: Three.Loader;
    } & {
        size: {
            width: number | undefined;
            height: number | undefined;
        };
        progress: {
            startedAt?: number | undefined;
            endedAt?: number | undefined;
            isComplete: boolean;
            lengthComputable: boolean;
            loaded: number;
            total: number;
        };
    }, {
        loadProgressPercentage(): number;
    }, {
        onResize(): void;
        onMouseDown(event: MouseEvent): void;
        onMouseMove(event: MouseEvent): void;
        onMouseUp(event: MouseEvent): void;
        onClick(event: MouseEvent): void;
        onDblclick(event: MouseEvent): void;
        pick(x: number, y: number): Three.Intersection<Three.Object3D<Three.Event>> | null | undefined;
        update(): void;
        updateModel(): void;
        updateRenderer(): void;
        updateCamera(): void;
        updateLights(): void;
        updateControls(): void;
        reportProgress(type: "start" | "end" | "progress", data?: {
            lengthComputable: boolean;
            loaded: number;
            total: number;
        } | undefined): void;
        load(): void;
        process(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        getObject(object: Three.Object3D<Three.Event>): Three.Object3D<Three.Event>;
        addObject(object: Three.Object3D<Three.Event>): void;
        animate(): void;
        render(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        src: {
            type: StringConstructor;
        };
        width: {
            type: NumberConstructor;
        };
        height: {
            type: NumberConstructor;
        };
        position: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        rotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        scale: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        lights: {
            type: import("vue").PropType<{
                [key: string]: any;
                type: string;
            }[]>;
            default: () => never[];
        };
        cameraPosition: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraRotation: {
            type: ObjectConstructor;
            default: () => {
                x: number;
                y: number;
                z: number;
            };
        };
        cameraUp: {
            type: ObjectConstructor;
        };
        cameraLookAt: {
            type: ObjectConstructor;
        };
        backgroundColor: {
            default: number;
        };
        backgroundAlpha: {
            type: NumberConstructor;
            default: number;
        };
        controlsOptions: {
            type: ObjectConstructor;
        };
        crossOrigin: {
            type: StringConstructor;
            default: string;
        };
        requestHeader: {
            type: ObjectConstructor;
            default: () => void;
        };
        outputEncoding: {
            type: NumberConstructor;
            default: Three.TextureEncoding;
        };
        glOptions: {
            type: ObjectConstructor;
        };
    }>>, {
        position: Record<string, any>;
        rotation: Record<string, any>;
        scale: Record<string, any>;
        lights: {
            [key: string]: any;
            type: string;
        }[];
        backgroundAlpha: number;
        backgroundColor: number;
        cameraPosition: Record<string, any>;
        cameraRotation: Record<string, any>;
        crossOrigin: string;
        requestHeader: Record<string, any>;
        outputEncoding: number;
    }>, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        lights: {
            type: ArrayConstructor;
            default: () => ({
                type: string;
                color: number;
                position?: undefined;
                intensity?: undefined;
            } | {
                type: string;
                position: {
                    x: number;
                    y: number;
                    z: number;
                };
                color: number;
                intensity: number;
            })[];
        };
        gammaOutput: {
            type: BooleanConstructor;
            default: boolean;
        };
    }>>, {
        lights: unknown[];
        gammaOutput: boolean;
    }>;
};
export default _default;
export { install, ModelObj, ModelFbx, ModelThree, ModelJson, ModelStl, ModelPly, ModelCollada, ModelDae, ModelGltf, };
