import { Object3D, Vector2, Scene, Light, Raycaster, WebGLRenderer, PerspectiveCamera, Loader } from 'three';
import { OrbitControls } from 'three/examples/jsm/controls/OrbitControls';
import { PropType } from 'vue';
declare const _default: import("vue").DefineComponent<{
    src: {
        type: StringConstructor;
    };
    width: {
        type: NumberConstructor;
    };
    height: {
        type: NumberConstructor;
    };
    position: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    rotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    scale: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    lights: {
        type: PropType<{
            [key: string]: any;
            type: string;
        }[]>;
        default: () => never[];
    };
    cameraPosition: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraRotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraUp: {
        type: ObjectConstructor;
    };
    cameraLookAt: {
        type: ObjectConstructor;
    };
    backgroundColor: {
        default: number;
    };
    backgroundAlpha: {
        type: NumberConstructor;
        default: number;
    };
    controlsOptions: {
        type: ObjectConstructor;
    };
    crossOrigin: {
        type: StringConstructor;
        default: string;
    };
    requestHeader: {
        type: ObjectConstructor;
        default: () => void;
    };
    outputEncoding: {
        type: NumberConstructor;
        default: import("three").TextureEncoding;
    };
    glOptions: {
        type: ObjectConstructor;
    };
}, unknown, {
    object: Object3D<import("three").Event> | null;
    raycaster: Raycaster;
    mouse: Vector2;
    camera: PerspectiveCamera;
    scene: Scene;
    wrapper: Object3D<import("three").Event>;
    renderer: WebGLRenderer | null;
    controls: OrbitControls | null;
    allLights: Light[];
    clock: DateConstructor | Performance;
    reqId: number | null;
    loader: Loader;
} & {
    size: {
        width: number | undefined;
        height: number | undefined;
    };
    progress: {
        startedAt?: number | undefined;
        endedAt?: number | undefined;
        isComplete: boolean;
        lengthComputable: boolean;
        loaded: number;
        total: number;
    };
}, {
    loadProgressPercentage(): number;
}, {
    onResize(): void;
    onMouseDown(event: MouseEvent): void;
    onMouseMove(event: MouseEvent): void;
    onMouseUp(event: MouseEvent): void;
    onClick(event: MouseEvent): void;
    onDblclick(event: MouseEvent): void;
    pick(x: number, y: number): import("three").Intersection<Object3D<import("three").Event>> | null | undefined;
    update(): void;
    updateModel(): void;
    updateRenderer(): void;
    updateCamera(): void;
    updateLights(): void;
    updateControls(): void;
    reportProgress(type: 'start' | 'end' | 'progress', data?: {
        lengthComputable: boolean;
        loaded: number;
        total: number;
    }): void;
    load(): void;
    process(object: Object3D): Object3D<import("three").Event>;
    getObject(object: Object3D): Object3D<import("three").Event>;
    addObject(object: Object3D): void;
    animate(): void;
    render(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    src: {
        type: StringConstructor;
    };
    width: {
        type: NumberConstructor;
    };
    height: {
        type: NumberConstructor;
    };
    position: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    rotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    scale: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    lights: {
        type: PropType<{
            [key: string]: any;
            type: string;
        }[]>;
        default: () => never[];
    };
    cameraPosition: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraRotation: {
        type: ObjectConstructor;
        default: () => {
            x: number;
            y: number;
            z: number;
        };
    };
    cameraUp: {
        type: ObjectConstructor;
    };
    cameraLookAt: {
        type: ObjectConstructor;
    };
    backgroundColor: {
        default: number;
    };
    backgroundAlpha: {
        type: NumberConstructor;
        default: number;
    };
    controlsOptions: {
        type: ObjectConstructor;
    };
    crossOrigin: {
        type: StringConstructor;
        default: string;
    };
    requestHeader: {
        type: ObjectConstructor;
        default: () => void;
    };
    outputEncoding: {
        type: NumberConstructor;
        default: import("three").TextureEncoding;
    };
    glOptions: {
        type: ObjectConstructor;
    };
}>>, {
    position: Record<string, any>;
    rotation: Record<string, any>;
    scale: Record<string, any>;
    lights: {
        [key: string]: any;
        type: string;
    }[];
    backgroundAlpha: number;
    backgroundColor: number;
    cameraPosition: Record<string, any>;
    cameraRotation: Record<string, any>;
    crossOrigin: string;
    requestHeader: Record<string, any>;
    outputEncoding: number;
}>;
export default _default;
